{% extends "ajax/game/game.html.twig" %}
{% block ajax %}
    <div class="row">
        <div class="cell padded header rw-12">
            <h4>{% trans from 'ghost' %}Wähle eine Stadt{% endtrans %}{% if canCreateTown %}<span class="link float-right" x-ajax-href="{{ path('ghost_create_town') }}">{{'Privatstadt gründen'|trans({}, 'ghost')}}</span>{% endif %}</h4>
            <div class="row">
                <div class="cell rw-8 rw-md-12">
                    {% for townClass in townClasses %}

                        {% set joinable = userCanJoin[townClass.name] %}
                        {% set found = false %}
                        {% for town in townClass.towns %}
                            {% if town.open %}{% set found = true %}{% endif %}
                        {% endfor %}

                        <h5>{{ townClass.getLabel|trans({},'game') }}</h5>
                        {% if found %}
                            <div class="row-table">
                                <div class="row header">
                                    <div class="padded cell rw-6">{% trans from 'ghost' %}Stadtname{% endtrans %}</div>
                                    <div class="padded cell rw-2">{% trans from 'game' %}Bürger{% endtrans %}</div>
                                    <div class="padded cell rw-4">{% trans from 'ghost' %}Aktionen{% endtrans %}</div>
                                </div>
                                {% for town in townClass.towns %}
                                    {# @var town \App\Entity\Town #}
                                    {% if town.open and not town.userInTown(app.user) %}
                                        {% set found = true %}
                                        <div class="row town-row">
                                            <div class="padded cell rw-1"><span class="language"><img src="{{ asset("build/images/lang/" ~ town.getLanguage ~".png") }}" alt="{{ town.getLanguage }}" /></span></div>
                                            <div class="padded cell rw-5">{% if town.password is not null %}<img src="{{ asset('build/images/item/item_lock.gif') }}" alt="Verrouillé" />{% endif %} {{ town.getName }}</div>
                                            <div class="padded cell rw-2">{{ town.citizens|length }}/{{ town.population }}</div>
                                            <div class="padded cell rw-1 center"><img x-town-details="{{ town.id }}" x-town-toggle="{{ town.id }}" class="pointer" alt="+" src="{{ asset('build/images/icons/small_more.gif') }}" /><div class="tooltip help">{{ 'Die Liste der eingeschriebenen Spieler ansehen.'|trans({},'game') }}</div></div>
                                            <div class="padded cell rw-3"><button {% if joinable %}x-town-lang="{{ town.getLanguage }}" x-town-id="{{ town.id }}" x-town-name="{{ town.getName }}" x-town-locked="{% if town.password is not null %}1{% else %}0{% endif %}" {% else %}disabled="disabled" title="{{ 'Deine Seele genügt den Anforderungen für diesen Stadttypen.'|trans({}, 'ghost') }}"{% endif %}>{% trans from 'ghost' %}Beitreten{% endtrans %}</button></div>
                                            <div x-town-details="{{ town.id }}" class="padded cell rw-12 hidden" style="background-color: #3b3249;">
                                                <ul class="citizen-list">
                                                    {% for denizen in town.citizens %}
                                                        {# @var denizen \App\Entity\Citizen #}
                                                        <li>
                                                            {% if denizen.alive %}
                                                                <img src="{{ asset('build/images/professions/' ~ denizen.profession.icon ~ '.gif') }}" alt="{{ denizen.profession.label|trans({},'game') }}" />
                                                            {% else %}
                                                                <img src="{{ asset('build/images/professions/death.gif') }}" alt="{{ denizen.profession.label|trans({},'game') }}" />
                                                            {% endif %}
                                                            <a class="link" href="{{ path('soul_visit', {id: denizen.user.id}) }}">{{ denizen.user.name }}</a>
                                                        </li>
                                                    {% endfor %}
                                                </ul>
                                                <div class="right"><span class="small pointer" x-town-toggle="{{ town.id }}">{{ 'Schließen'|trans({},'global') }}</span></div>
                                            </div>
                                        </div>
                                    {% endif %}
                                {% endfor %}
                            </div>

                        {% else %}
                            <span class="small">{% trans from 'ghost' %}Aktuell gibt es keine Stadt diesen Typs.{% endtrans %}</span>
                        {% endif %}
                    {% endfor %}
                </div>
                <div class="cell rw-4 rw-md-12">
                    ADD HELP CONTENT HERE
                </div>
            </div>

        </div>
    </div>
{% endblock %}
{% block js %}
    {{parent()}}
    <script>
        $.html.addEventListenerAll( '[x-town-toggle]', 'click', function(e,elem) {
            const id = elem.getAttribute('x-town-toggle');
            document.querySelectorAll('[x-town-details="' + id + '"]').forEach(function( target ) {
                if (target.classList.contains('hidden')) target.classList.remove('hidden');
                else target.classList.add('hidden');
            })
        } );

        $.html.addEventListenerAll( 'button[x-town-id][x-town-lang]', 'click', function(e,elem) {
            e.preventDefault();
            const user_lang = '{{ app.request.locale|e('js') }}';
            const town_lang = elem.getAttribute('x-town-lang');
            const town_name = elem.getAttribute('x-town-name');
            if (user_lang && town_lang && user_lang.split('_')[0] !== town_lang.split('_')[0]) {
                const user_lang_rep = window.c.langs[user_lang.split('_')[0]] ? window.c.langs[user_lang.split('_')[0]] : user_lang;
                const town_lang_rep = window.c.langs[town_lang.split('_')[0]] ? window.c.langs[town_lang.split('_')[0]] : town_lang;
                let message =
                    ('{{ 'Die Sprache der gewählten Stadt ist %lang_town%. Deine aktuelle Spracheinstellung ist %lang_user%.'|trans({},'ghost')|e('js') }}' + "\n\n" +
                    '{{ 'Kommunikation ist wichtig in MyHordes. Bitte betritt keine Stadt, deren Sprache du nicht beherrscht. Möchtest du fortfahren?'|trans({},'ghost')|e('js') }}')
                    .replace(/%lang_user%/g, user_lang_rep).replace(/%lang_town%/g, town_lang_rep);

                if (!confirm(message)) return;
            } else if (!confirm('{{ 'Möchtest du die schreckliche Welt der Verdammten als Bürge der Stadt %town_name% betreten'|trans({},'ghost')|e('js') }} ?'.replace('%town_name%', town_name)))
                return;

            if (elem.getAttribute('x-town-locked') == 1) {
                let pass = prompt('{{ 'Bitte gib das Stadtpasswort ein :'|trans({}, 'ghost') }}');
                $.ajax.easySend( '{{ path('api_check_town_pw') }}', {town: elem.getAttribute('x-town-id'), pass: pass},
                    function (response) {
                        $.ajax.load(null, '{{ path('game_landing') }}', true);
                    }
                );
            } else {
                $.ajax.easySend( '{{ path('api_join') }}', {town: elem.getAttribute('x-town-id')},
                    function () {
                        $.ajax.load(null, '{{ path('game_landing') }}', true);
                    }
                );
            }
        } );
    </script>
{% endblock %}